using System;
using ProtoBuf;
using Fantasy;
using System.Linq;
using System.Reflection;
using System.Collections.Generic;
using System.Collections.Concurrent;
using Fantasy.Serialize;
using Fantasy.ConfigTable;

namespace NBF
{
    [ProtoContract]
    public sealed partial class LineConfig : ASerialize, IProto, IConfigTable
    {
    
		[ProtoMember(1)]
		public uint Id { get; set; } // Id
		[ProtoMember(2)]
		public string Model { get; set; } // 模型
		[ProtoMember(3)]
		public uint Type { get; set; } // 类型
		[ProtoMember(4)]
		public uint Length { get; set; } // 长度（毫米）
		[ProtoMember(5)]
		public uint Strength { get; set; } // 强度
		[ProtoMember(6)]
		public uint Size { get; set; } // 尺寸  
        [ProtoIgnore]
        public uint Key => Id;
        
        #region Static
        
        private static ConfigContext<LineConfig> Context => ConfigTableHelper.Table<LineConfig>();

        public static LineConfig Get(uint key)
        {
            return Context.Get(key);
        }

        public static LineConfig Get(Predicate<LineConfig> match)
        {
            return Context.Get(match);
        }
        
        public static LineConfig Fist()
        {
            return Context.Fist();
        }

        public static LineConfig Last()
        {
            return Context.Last();
        }

        public static LineConfig Fist(Predicate<LineConfig> match)
        {
            return Context.Fist(match);
        }

        public static LineConfig Last(Predicate<LineConfig> match)
        {
            return Context.Last(match);
        }
        
        public static int Count()
        {
            return Context.Count();
        }

        public static int Count(Func<LineConfig, bool> predicate)
        {
            return Context.Count(predicate);
        }

        public static List<LineConfig> GetList()
        {
            return Context.GetList();
        }

        public static List<LineConfig> GetList(Predicate<LineConfig> match)
        {
            return Context.GetList(match);
        }
        public static void ParseJson(Newtonsoft.Json.Linq.JArray arr)
        {
            ConfigTableHelper.ParseLine<LineConfig>(arr);
        }
        #endregion
    }
}